<html>
<head>
<title>OgreMovablePlane.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreMovablePlane.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreMovablePlane_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __MovablePlane_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __MovablePlane_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgrePlane_8h.html">OgrePlane.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreMovableObject_8h.html">OgreMovableObject.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>Ogre {
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00053"></a><a class="code" href="classOgre_1_1MovablePlane.html">00053</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1MovablePlane.html" title="Definition of a Plane that may be attached to a node, and the derived details of it retrieved simply...">MovablePlane</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a>, <span class="keyword">public</span> <a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a>
<a name="l00054"></a>00054     {
<a name="l00055"></a>00055     <span class="keyword">protected</span>:
<a name="l00056"></a><a class="code" href="classOgre_1_1MovablePlane.html#ab418c04fe6256374b4c9646a6da4e43b">00056</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a> <a class="code" href="classOgre_1_1MovablePlane.html#ab418c04fe6256374b4c9646a6da4e43b">mDerivedPlane</a>;
<a name="l00057"></a><a class="code" href="classOgre_1_1MovablePlane.html#a1a931f127eec4fa7bc25d94c7407497e">00057</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1MovablePlane.html#a1a931f127eec4fa7bc25d94c7407497e">mLastTranslate</a>;
<a name="l00058"></a><a class="code" href="classOgre_1_1MovablePlane.html#a116c680731053e84575e63a99c5480d9">00058</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> <a class="code" href="classOgre_1_1MovablePlane.html#a116c680731053e84575e63a99c5480d9">mLastRotate</a>;
<a name="l00059"></a><a class="code" href="classOgre_1_1MovablePlane.html#ad5f6825e61579ef77a0425d2855817ae">00059</a>         <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a> <a class="code" href="classOgre_1_1MovablePlane.html#ad5f6825e61579ef77a0425d2855817ae">mNullBB</a>;
<a name="l00060"></a><a class="code" href="classOgre_1_1MovablePlane.html#ad8f054ccf0f2c7ec0662bf29c83f2c52">00060</a>         <span class="keyword">mutable</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1MovablePlane.html#ad8f054ccf0f2c7ec0662bf29c83f2c52">mDirty</a>;
<a name="l00061"></a><a class="code" href="classOgre_1_1MovablePlane.html#afdac080d7abbc712c691bd138984ee1f">00061</a>         <span class="keyword">static</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1MovablePlane.html#afdac080d7abbc712c691bd138984ee1f">msMovableType</a>;
<a name="l00062"></a>00062     <span class="keyword">public</span>:
<a name="l00063"></a>00063 
<a name="l00064"></a>00064         <a class="code" href="classOgre_1_1MovablePlane.html" title="Definition of a Plane that may be attached to a node, and the derived details of it retrieved simply...">MovablePlane</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00065"></a>00065         <a class="code" href="classOgre_1_1MovablePlane.html" title="Definition of a Plane that may be attached to a node, and the derived details of it retrieved simply...">MovablePlane</a> (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a>&amp; rhs);
<a name="l00067"></a>00067         <a class="code" href="classOgre_1_1MovablePlane.html" title="Definition of a Plane that may be attached to a node, and the derived details of it retrieved simply...">MovablePlane</a> (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkNormal, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fConstant);
<a name="l00068"></a>00068         <a class="code" href="classOgre_1_1MovablePlane.html" title="Definition of a Plane that may be attached to a node, and the derived details of it retrieved simply...">MovablePlane</a> (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkNormal, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkPoint);
<a name="l00069"></a>00069         <a class="code" href="classOgre_1_1MovablePlane.html" title="Definition of a Plane that may be attached to a node, and the derived details of it retrieved simply...">MovablePlane</a> (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkPoint0, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkPoint1,
<a name="l00070"></a>00070             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkPoint2);
<a name="l00071"></a><a class="code" href="classOgre_1_1MovablePlane.html#aa455a864932accb9c98744f1a88ddfa4">00071</a>         <a class="code" href="classOgre_1_1MovablePlane.html#aa455a864932accb9c98744f1a88ddfa4">~MovablePlane</a>() {}
<a name="l00073"></a><a class="code" href="classOgre_1_1MovablePlane.html#a6d0680e3e68f81a9498c30d5257d4293">00073</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1MovablePlane.html#a6d0680e3e68f81a9498c30d5257d4293" title="Overridden from MovableObject.">_notifyCurrentCamera</a>(<a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>*) { <span class="comment">/* don&#39;t care */</span> }
<a name="l00075"></a><a class="code" href="classOgre_1_1MovablePlane.html#afa11bf26dca26f035326d8b3d29f9b97">00075</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; <a class="code" href="classOgre_1_1MovablePlane.html#afa11bf26dca26f035326d8b3d29f9b97" title="Overridden from MovableObject.">getBoundingBox</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mNullBB; }
<a name="l00077"></a><a class="code" href="classOgre_1_1MovablePlane.html#a204ccd522575f1008417a0fcf5bd5a83">00077</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1MovablePlane.html#a204ccd522575f1008417a0fcf5bd5a83" title="Overridden from MovableObject.">getBoundingRadius</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 0.0f; }
<a name="l00079"></a><a class="code" href="classOgre_1_1MovablePlane.html#a68ae3348d74c55872c29d54a19ede2cf">00079</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1MovablePlane.html#a68ae3348d74c55872c29d54a19ede2cf" title="Overridden from MovableObject.">_updateRenderQueue</a>(<a class="code" href="classOgre_1_1RenderQueue.html" title="Class to manage the scene object rendering queue.">RenderQueue</a>*) { <span class="comment">/* do nothing */</span>}
<a name="l00081"></a>00081         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getMovableType(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00083"></a>00083         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a>&amp; _getDerivedPlane(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00085"></a><a class="code" href="classOgre_1_1MovablePlane.html#a8f7adfc984a3b93cb87ea36286ce2a52">00085</a>         <span class="keywordtype">void</span> visitRenderables(<a class="code" href="classOgre_1_1Renderable_1_1Visitor.html" title="Visitor object that can be used to iterate over a collection of Renderable instances abstractly...">Renderable::Visitor</a>* visitor, 
<a name="l00086"></a>00086             <span class="keywordtype">bool</span> debugRenderables = <span class="keyword">false</span>)
<a name="l00087"></a>00087                 {
<a name="l00088"></a>00088                     <span class="comment">/* do nothing */</span>
<a name="l00089"></a>00089                     (void)visitor;
<a name="l00090"></a>00090                     (void)debugRenderables;
<a name="l00091"></a>00091                 }
<a name="l00092"></a>00092 
<a name="l00093"></a>00093     };
<a name="l00096"></a>00096 }
<a name="l00097"></a>00097 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
